<?php

$link = 'http://example.com';

// get HTML using PHP core function
$html = file_get_contents($link);

// Extract the Open Graph metadata tags using regular expression
$ogMetaTags = [];
if (preg_match_all('/<meta property="og:([^"]+)"\s*content="([^"]*)"/i', $html, $matches)) {
    $ogMetaTags = array_combine($matches[1], $matches[2]);
}

?>

<!DOCTYPE html>
<html>

<head>
    <title>How to get metadata from webpage link to show preview in PHP</title>
    <link rel="stylesheet" type="text/css" href="style.css" />
</head>

<body>
    <div class="phppot-container">
        <!-- Create webpage link preview with open graph meta tags -->
        <div class="site-preview">
            <h2><?php echo $ogMetaTags['title']; ?></h2>
            <!-- Check if 'og:image' is set before including it in the HTML -->
            <?php
            if (isset($ogMetaTags['image'])) {
            ?>
            <img src="<?php echo $ogMetaTags['image']; ?>" alt="Site Logo" width="100%"></p>
            <?php
            }
            ?>
            <p><?php echo $ogMetaTags['description']; ?></p>
        </div>
    </div>
</body>

</html>