<?php

function getSiteHTMLViaCURL($url)
{
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $siteHTML = curl_exec($ch);
    if (curl_errno($ch)) {
        return false;
    }
    curl_close($ch);
    return $siteHTML;
}

function getMetadataFromHTML($siteHTML)
{
    
    // Get the webpage metadata
    $metadataArray = [];
    if (preg_match_all('/<meta property="og:([^"]+)"\s*content="([^"]*)"/i', $siteHTML, $matches)) {
        $metadataArray = array_combine($matches[1], $matches[2]);
    }
    return $metadataArray;
}

function generatePreviewHTML($metadataArray)
{
    // Generate HTML with webpage link preview
    $previewHTML = '<div class="site-preview">';
    $previewHTML .= '<h1>' . $metadataArray['title'] . '</h1>';
    $previewHTML .= '<p>' . $metadataArray['description'] . '</p>';

    if (isset($linkPreview['image'])) {
        $previewHTML .= '<p><img src="' . $metadataArray['image'] . '" alt="Site Logo"></p>';
    }

    $previewHTML .= '</div>';

    return $previewHTML;
}

$link = 'https://www.allrecipes.com/gallery/easter-brunch-casseroles/';
$siteHTML = getSiteHTMLViaCURL($link);
$metadataArray = getMetadataFromHTML($siteHTML);
?>
<!DOCTYPE html>
<html>

<head>
    <title>How to get metadata from webpage link to show preview in PHP</title>
    <link rel="stylesheet" type="text/css" href="style.css" />
</head>

<body>
    <div class="phppot-container">
        <?php
        echo generatePreviewHTML($metadataArray);
        ?>
    </div>
</body>

</html>